package com.jclark.xsl;

class ComposeQuery implements SubQuery {
  private SubQuery query1;
  private SubQuery query2;
  
  ComposeQuery(SubQuery query1, SubQuery query2) {
    this.query1 = query1;
    this.query2 = query2;
  }

  public SubQuery createUnion(SubQuery query) {
    if (query instanceof ComposeQuery) {
      ComposeQuery c = (ComposeQuery)query;
      SubQuery temp1 = query1.createUnion(c.query1);
      if (temp1 != null) {
	SubQuery temp2 = query2.createUnion(c.query2);
	if (temp2 != null)
	  return new ComposeQuery(temp1, temp2);
      }
    }
    return null;
  }

  public NodeIterator select(ProcessContext context, Node node) {
    return new ComposeNodeIterator(context, query1.select(context, node), query2);
  }
}
