package com.jclark.xsl;

class FirstOfTypeQualifier extends Qualifier {
  private boolean negated;
  FirstOfTypeQualifier(boolean negated, Qualifier next) {
    super(next);
    this.negated = negated;
  }
  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    Name name = node.getName();
    for (NodeIterator iter = node.getParent().getChildren(true);;) {
      Node tem = iter.next();
      if (tem.equals(node))
	break;
      if (tem.getType() == Node.ELEMENT && tem.getName().equals(name))
	return negated ? true : false;
    }
    return negated ? false : true;
  }
}
