package com.jclark.xsl;

class ForEachAction implements Action {
  private Query query;
  private Action action;

  ForEachAction(Query query, Action action) {
    this.query = query;
    this.action = action;
  }

  public void invoke(ProcessContext context, Node sourceNode, Result result) throws XSLException {
    for (NodeIterator iter = query.select(context, sourceNode);;) {
      Node nd = iter.next();
      if (nd == null)
	break;
      action.invoke(context, nd, result);
    }
  }
}

