package com.jclark.xsl;

class InvokeAction implements Action {
  private Name name;
  private AttributeListTemplate attributesTemplate;
  private Action contents;
  InvokeAction(Name name, AttributeListTemplate attributesTemplate, Action contents) throws XSLException {
    this.name = name;
    this.attributesTemplate = attributesTemplate;
    this.contents = contents;
  }
  public void invoke(ProcessContext context, Node sourceNode, Result result) throws XSLException {
    AttributeList attributes = attributesTemplate.instantiate(context, sourceNode);
    Macro macro = context.getMacro(name);
    if (macro != null)
      macro.invoke(attributes, contents, context, sourceNode, result);
  }
}
