package com.jclark.xsl;

class MacroImpl implements Macro {
  private Action body;
  private MacroArgumentList attributesTemplate;

  MacroImpl(MacroArgumentList attributesTemplate, Action body) {
    this.attributesTemplate = attributesTemplate;
    this.body = body;
  }
    
  public
  void invoke(AttributeList actualAttributes,
	      Action contents,
	      ProcessContext context,
	      Node sourceNode,
	      Result result) throws XSLException {
    // FIXME String expressions in default values should
    // get access to previous arguments.
    AttributeList formalAttributes = attributesTemplate.instantiate(context, sourceNode);
    body.invoke(new MacroProcessContext(context,
					sourceNode,
					formalAttributes,
					actualAttributes,
					contents),
		sourceNode,
		result);
  }
}

  
